
//     SIMULATION ORAGE #1-A
//     Hubert SPERI
//     20/12/2021
//     Modifié : 29/01/2022
//_________________________

//ADUINO UNO ou NANO
//DFPlayer MINI : lecteur de fichier MP3
//_________________________

//Le départ et l'arrêt du cycle sont commandés par infrarouge.
//J'ai utilisé les codes SONY TV des touches numériques.

// CODE à 2 CHIFFRES POUR L'APPLICATION «ORAGE» :
// -- 10 (Touche_1 ; Touche_0) : code de mise en route pour un orage de 1 salves ;
// -- 11 (Touche_1 ; Touche_1) : code de mise en route pour un orage de 4 salves ;
// -- 12 (Touche_1 ; Touche_2) : code de mise en route pour un orage de 8 salves ;
// -- 13 (Touche_1 ; Touche_3) : code de mise en route pour un orage de 16 salves ;
// -- 14 (Touche_1 ; Touche_4) : code de mise en route pour la pluie ;
// -- 19 (Touche_1 ; Touche_9) : code d'arrêt ;
// -- (Touche_1 ; Touche_POWER) : code d'arrêt ;

//_________________________

//SEQUENCES SONORES
//
//Les séquences sonores que j'ai utilisées durent quelques secondes chacunes.
//Elles ont été composées sur AUDACITY, à partir d'enregistrements de sons réels.

//_________________________

//ENTREES - SORTIES

//-- LED pour les éclairs  : sortie «9» qui commande un MOSFET ;

//-- capteur infrarouge : entrée «4» ;

//-- Rx de l'ARDUINO : broche «2», reliée à la broche «Tx» du DFPlayer ;
//-- Tx de l'ARDUINO : broche «3», reliée à la broche «Rx» du DFPlayer ;
//-- Broche «BUSY» du DFPlayer : entrée «5».

// Note : dans ce programme, la liason «Rx ARDUINO» vers «Tx DFPlayer» n'est pas utilisée.



//___________________________________________________________________________


#include <IRremote.h>
#include <SoftwareSerial.h>
#include <DFRobotDFPlayerMini.h>

int IRpin = 4 ;                          // entrée du capteur IR
IRrecv irrecv(IRpin);
decode_results results;


// Seules les touches utilisées pour cette application sont «libérées» :

        const int  Touche_9 = 272 ; 
//const int  Touche_8 = 3600 ; 
//const int  Touche_7 = 1552 ;
//const int  Touche_6 = 2576 ;
//const int  Touche_5 = 528 ;
        const int  Touche_4 = 3088 ;
        const int  Touche_3 = 1040 ;
        const int  Touche_2 = 2064 ;
        const int  Touche_1 = 16 ;
        const int  Touche_0 = 2320 ;
//const int  Touche_Up = 1904 ;
//const int  Touche_Down = 3952 ;
//const int  Touche_Left = 2800 ;
//const int  Touche_Right = 752 ;
//const int  Touche_VolUp = 1168 ;
//const int  Touche_VolDown = 3216 ;
//const int  Touche_CH_Up = 144 ;
//const int  Touche_CH_Down = 2192 ;
  const int  Touche_POWER = 2704 ;
//const int  Touche_Menu = 112 ;

const int Numero_du_son_de_la_pluie = 15 ;

//--- Variables globales ---

int Numero_du_son;
int Volume;
int Retard;
int Facteur_d_intensite;
int Proximite;

int Nombre_de_sons_enregistres ;

int Duree_de_l_orage ;                     // Détermine le nombre de salves (et coups de tonnerre) de l'orage complet.
                                         
const int Liaison_BUSY = 10 ;
const int MOSFET = 9 ;

SoftwareSerial mySoftwareSerial(2,3);
DFRobotDFPlayerMini myDFPlayer;

//------------------------------------------------------------------------------------------------------------------------------


/*

void pushReset()                   // Cette fonction simule la pression du bouton Reset 
{ 
  int pin=12; 
  // active la broche en sortie (OUTPUT)  
  pinMode(pin, OUTPUT); 
  // Déactive le reset forçant la sortie au niveau bas 
  digitalWrite(pin, LOW);
}


// Redémarre le programme depuis le début mais ne 
// réinitialise pas les périphériques et les registres
void software_Reset()
{
  asm volatile ("  jmp 0"); 
} 


*/




int Interception_du_premier_code_IR_SONY()        // Appelée par la fonction «Code_a_2_chiffres».
                                                  // Cette fonction attend indéfiniment la saisie du premier code.
{
int Code_touche_obtenu = 999 ;  // On impose a priori un code incorrect hors du champs des codes possibles.
                                // Le code «999» n'existe pas dans la liste de codes de la télécommande SONY TV.
irrecv.resume() ;
    
            while (!(irrecv.decode(&results)))     // Attend indéfiniment (sans rien faire) la réception du 1er code.
                  {
                  // boucle d'attente
                  delay(100) ;
                  }
             Code_touche_obtenu = results.value ;  
                  //Serial.print("    Code touche obtenu pour le 1er chiffre = ") ;
                  //Serial.println(Code_touche_obtenu) ;
                                        
             delay(600) ;                           // Delai avant la saisie du code suivant
             irrecv.resume() ;
                                       
             return Code_touche_obtenu ;            
}  





// Appelée par la fonction «Code_a_2_chiffres».
// Pour le 2e code, le délai de saisie en secondes est limité par la valeur de «Limite_du_delai_d_attente».
// Passé ce délai, on revient au début de void loop pour attendre un nouveau premier code.

int Interception_du_premier_code_IR_SONY_avec_delay()       
{
int Code_touche_obtenu = 999 ;
int Limite_du_delai_d_attente = 2 ;
irrecv.resume() ;
    
            int Temps_IN = millis() / 1000 ;
            int Temps_OUT ;
            while (!(irrecv.decode(&results)))         // Attend la réception du 2e code pendant «Limite_du_delai_d_attente», en secondes.
                  {
                  // boucle d'attente
                  delay(100) ;
                  int Temps_OUT = millis() / 1000 ;
                  if ((Temps_OUT - Temps_IN) > Limite_du_delai_d_attente) 
                     {
                     //Serial.println("        Dépassement du temps 1er chiffre") ; 
                     return 999 ; 
                     }
                  }
             Code_touche_obtenu = results.value ;  
                  //Serial.print("    Code touche obtenu pour le 1er chiffre = ") ;
                  //Serial.println(Code_touche_obtenu) ;
                                        
             delay(600) ;    // Delai avant la saisie du code suivant
             irrecv.resume() ;
                                       
             return Code_touche_obtenu ;            
}  





// Appelée par la fonction «Code_a_2_chiffres».
// Pour le 2e code, le délai de saisie en secondes est limité par la valeur de «Limite_du_delai_d_attente».
// Passé ce délai, on revient au début de void loop pour attendre un nouveau premier code.

int Interception_du_deuxieme_code_IR_SONY()
{
int Code_touche_obtenu = 999 ;
int Limite_du_delai_d_attente = 2 ;
irrecv.resume() ;
  
            int Temps_IN = millis() / 1000 ;
            while (!(irrecv.decode(&results)))         // Attend la réception du 2e code pendant «Limite_du_delai_d_attente», en secondes.
               {
               // boucle d'attente à durée limitée.
               delay(100) ;
               int Temps_OUT = millis() / 1000 ;
               if ((Temps_OUT - Temps_IN) > Limite_du_delai_d_attente) 
                  {
                  //Serial.println("        Dépassement du temps 2e chiffre") ; 
                  return 999 ; 
                  }
               }
             Code_touche_obtenu = results.value ;  
                  //Serial.print("    Code touche obtenu pour le 2e chiffre = ") ;
                  //Serial.println(Code_touche_obtenu) ;
                                                  
             irrecv.resume() ;
                                        
             delay(1000) ;    // Delai avant la saisie du code suivant
             results.value = 0 ;
             irrecv.resume() ;
                                        
             return Code_touche_obtenu ;            
}  






int Code_a_2_chiffres()
   {
   bool Code = false ;
   
   int Premier_chiffre = Interception_du_premier_code_IR_SONY() ;
   int Deuxieme_chiffre = Interception_du_deuxieme_code_IR_SONY() ;
    
   if (Premier_chiffre == Touche_1) 
        {
        if (Deuxieme_chiffre == Touche_0)            {Code = true ; Duree_de_l_orage = 1 ; }     // 1 salve ;
        if (Deuxieme_chiffre == Touche_1)            {Code = true ; Duree_de_l_orage = 4 ; }     // 4 salves ;
        if (Deuxieme_chiffre == Touche_2)            {Code = true ; Duree_de_l_orage = 8 ; }     // ...
        if (Deuxieme_chiffre == Touche_3)            {Code = true ; Duree_de_l_orage = 16 ; }       
        if (Deuxieme_chiffre == Touche_4)            {Code = true ; Fin_de_l_orage() ; loop() ;}       
        //if (Deuxieme_chiffre == Touche_5)          {Code = true ; }             
        //if (Deuxieme_chiffre == Touche_6)          {Code = true ; }
        //if (Deuxieme_chiffre == Touche_7)          {Code = true ; }
        //if (Deuxieme_chiffre == Touche_8)          {Code = true ; }
        //if (Deuxieme_chiffre == Touche_9)          {Code = true ; }
        }  
           
   return Code ;
   }






int Code_d_arret_a_2_chiffres()
   {
   bool Code = false ;
    
   int Premier_chiffre = Interception_du_premier_code_IR_SONY_avec_delay() ;
   int Deuxieme_chiffre = Interception_du_deuxieme_code_IR_SONY() ;

   //Serial.print("            Traitement du code d'arrêt : ") ;
    
   if (Premier_chiffre == Touche_1) 
       {
        //if (Deuxieme_chiffre == Touche_0)          {Code = true ; }     
        //if (Deuxieme_chiffre == Touche_1)          {Code = true ; }  
        //if (Deuxieme_chiffre == Touche_2)          {Code = true ; }  
        //if (Deuxieme_chiffre == Touche_3)          {Code = true ; }       
        //if (Deuxieme_chiffre == Touche_4)          {Code = true ; }       
        //if (Deuxieme_chiffre == Touche_5)          {Code = true ; }             
        //if (Deuxieme_chiffre == Touche_6)          {Code = true ; }
        //if (Deuxieme_chiffre == Touche_7)          {Code = true ; }
        //if (Deuxieme_chiffre == Touche_8)          {Code = true ; }
        if (Deuxieme_chiffre == Touche_9)            {Code = true ; }
        if (Deuxieme_chiffre == Touche_POWER)        {Code = true ; }
        }  
   
   return Code ;
   }






int mathRandomInt(int min, int max) 
  {
  randomSeed(millis()) ;       // Ajouté le 23/01/2022. Pour se rapprocher d'un véritable tirage aléatoire.  
  if (min > max) 
    { 
    int temp = min;            // Swap min and max to ensure min is smaller.
    min = max;
    max = temp;
    }
  return min + (rand() % (max - min + 1));
  }





void Salve() 
  {
  int repeat = mathRandomInt(2, 4) * 5;                                 // Nombre d'éclairs par salve.
  for (int count = 0; count < repeat ; count++)                      
    {
    analogWrite(9, (mathRandomInt(1, 4) * (Facteur_d_intensite * 8))); // Intensité «haute» de l'éclair.
    delay((mathRandomInt(1, 4) * 25));                                  // Durée de l'intensité «haute».
    analogWrite(9, (mathRandomInt(0, 4) * (Facteur_d_intensite * 5)));  // Intensité «basse» de l'éclair.
    delay((mathRandomInt(1, 4) * 15));                                  // Durée de l'intensité «basse».
    }
  analogWrite(9, 0);
  }





void Coup_de_tonnerre() 
  {
  Numero_du_son = mathRandomInt(1, Nombre_de_sons_enregistres-1); // «... -1» pour exclure le son final de la pluie
  delay(Retard);
  myDFPlayer.volume(Volume);
  myDFPlayer.play(Numero_du_son);
  }





int Attente_fin_du_son()           // ... et interception du code d'arrêt.
{ 
  delay(1000);                     // Pour être sûr que la pin 10 (BUSY) est bien passée à «LOW».
  long Initialisation_timer = millis();
  long Duree_du_son = 0 ;
  
  //Serial.println("    Attente fin du son :") ;
  //Serial.println("    Fenêtre de saisie du code d'arrêt : c'est maintenant...") ;
  
  while (digitalRead(Liaison_BUSY) == LOW) 
     { 
     if (Code_d_arret_a_2_chiffres() == true) // Permet de saisir le code «19» pour écourter la durée de l'orage.
       {
       //Serial.println("                ==> Code d'arrêt = OK.") ;
       //Serial.println("                ==> L'orage a été interrompu.") ;
       
       irrecv.resume(); 
       delay(100) ;
       return 99 ;
       }     
     }     
  Duree_du_son = (millis() - Initialisation_timer) + 1000;
  /*
  Serial.print("Fin du son n° ") ;
  Serial.println(Numero_du_son) ;
  Serial.print("Durée du son = ") ;
  Serial.print(Duree_du_son) ;
  Serial.println(" millisecondes");  
  Serial.print("- Current elapsed time (ms) = ");
  Serial.println(millis());
  Serial.println("");
  */
}





void Retard_du_son_Volume_et_Facteur_d_intensite() 
{
  Proximite = mathRandomInt(1, 8) * 5;   // Aléatoire de 8 à 40 : Proximité = 5 ⇒ lointain ; Proximité = 40 ⇒ proche.
  Volume = Proximite;
  Retard = (40 - Proximite) * 100;       // Ce coefficient varie de «0» à 3200 (millisecondes)
  Facteur_d_intensite = Proximite / 5;   // Ce coefficient varie de 1 à 8.
  /*
  Serial.print("- Volume = ");
  Serial.println(Volume);
  Serial.print("- Retard = ");
  Serial.print(Retard);
  Serial.println(" millisecondes");
  Serial.print("- Facteur d\'intensité = ");
  Serial.println(Facteur_d_intensite);
*/
}





void Attente_du_code_de_demarrage() 
{
  //Serial.println("Attente code") ;
  while (!(Code_a_2_chiffres() == true)) 
  {
  //Serial.println("code non reçu ou incorrect. Nouvel essai...") ;
  irrecv.resume(); 
  delay(50) ;  
  }
}





void Fin_de_l_orage() 
{
  myDFPlayer.volume(20);
  myDFPlayer.play(Numero_du_son_de_la_pluie);
  Attente_fin_du_son() ;
}





void setup() 
{
  irrecv.enableIRIn();
  
  Serial.begin(9600);
  pinMode(MOSFET, OUTPUT);             // Sortie vers le MOSFET
  
  mySoftwareSerial.begin(9600);
  pinMode(Liaison_BUSY, INPUT);   // Indispensable pour tester la fin de la diffusion du son en cours.       
  
  myDFPlayer.begin(mySoftwareSerial);
  myDFPlayer.volume(20);

  Nombre_de_sons_enregistres = myDFPlayer.readFileCounts();

  //  ----EQUALIZER : PARAMETRAGES POSSIBLES
  
  //  myDFPlayer.EQ(DFPLAYER_EQ_NORMAL);
  //  myDFPlayer.EQ(DFPLAYER_EQ_POP);
  //  myDFPlayer.EQ(DFPLAYER_EQ_ROCK);
  myDFPlayer.EQ(DFPLAYER_EQ_JAZZ);
  //  myDFPlayer.EQ(DFPLAYER_EQ_CLASSIC);
  //  myDFPlayer.EQ(DFPLAYER_EQ_BASS);
}





void loop() 
{
  irrecv.resume() ;
  Attente_du_code_de_demarrage() ;
  /*
  Serial.println("") ;
  Serial.println("Début de l'orage") ;
  Serial.print("Nombre de coups de tonnerre programmés = ") ;
  Serial.println(Duree_de_l_orage) ;
  Serial.println(" ") ;
  */
  for (int count2 = 1; count2 <= Duree_de_l_orage; count2++) 
    {
    /*  
    Serial.println("-------------") ;
    Serial.print("COUP DE TONNERRE N° ") ;
    Serial.println(count2) ;
    */
    Retard_du_son_Volume_et_Facteur_d_intensite();
    Salve();
    Coup_de_tonnerre();
        if (Attente_fin_du_son() == 99) {break ; } // pour écourter la durée de l'orage.
                                                   // Le code d'arrêt doit être saisi pendant la diffusion du son.
    }
  Fin_de_l_orage();                                // Diffusion du son n°15 (pluie).

}
